<?php
/*  zingiri_forum.php
 Copyright 2008,2009 Erik Bogaerts
 Support site: http://www.zingiri.com

 This file is part of Zingiri Forum.

 Zingiri Forum is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Zingiri Forum is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Zingiri Forum; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
?>
<?php
/*
 Plugin Name: Zingiri Forum
 Plugin URI: http://www.zingiri.com/Forum
 Description: Zingiri Forum is a plugin that integrates the powerfull myBB bulletin board software with Wordpress. It brings one of the most powerfull free forum softwares in reach of Wordpress users.

 Author: EBO
 Version: 0.5
 Author URI: http://www.zingiri.com/
 */
define("ZING_FORUM_VERSION","0.5");

// Pre-2.6 compatibility for wp-content folder location
if (!defined("WP_CONTENT_URL")) {
	define("WP_CONTENT_URL", get_option("siteurl") . "/wp-content");
}
if (!defined("WP_CONTENT_DIR")) {
	define("WP_CONTENT_DIR", ABSPATH . "wp-content");
}

if (!defined("ZING_FORUM_PLUGIN")) {
	$zing_forum_plugin=str_replace(realpath(dirname(__FILE__).'/..'),"",dirname(__FILE__));
	$zing_forum_plugin=substr($zing_forum_plugin,1);
	define("ZING_FORUM_PLUGIN", $zing_forum_plugin);
}
$zing_footers[]=array('http://www.mybboard.net/','MyBB');

define("ZING_FORUM_URL", WP_CONTENT_URL . "/plugins/".ZING_FORUM_PLUGIN."/");

if (get_option('zing_forum_url')) {
	define("ZING_MYBB_URL", get_option('zing_forum_url'));
} else {
	define("ZING_MYBB_URL",ZING_FORUM_URL."mybb");
}

$zing_forum_version=get_option("zing_forum_version");
if ($zing_forum_version) {
	add_action("init","zing_forum_init");
	add_filter('wp_footer','zing_footers');
	add_filter('the_content', 'zing_forum_content', 10, 3);
	add_action('wp_head','zing_forum_header');
}
register_activation_hook(__FILE__,'zing_forum_activate');
register_deactivation_hook(__FILE__,'zing_forum_deactivate');

require_once(dirname(__FILE__) . '/includes/shared.inc.php');
require_once(dirname(__FILE__) . '/includes/http.class.php');
require_once(dirname(__FILE__) . '/includes/footer.inc.php');
require_once(dirname(__FILE__) . '/includes/integrator.inc.php');
require_once(dirname(__FILE__) . '/forum_cp.php');

/**
 * Activation: creation of database tables & set up of pages
 * @return unknown_type
 */
function zing_forum_activate() {
	global $wpdb;

	$prefix = $wpdb->prefix."zing_mybb_";

	$zing_forum_version=get_option("zing_forum_version");
	if (!$zing_forum_version)
	{
		add_option("zing_forum_version",ZING_FORUM_VERSION);
	}
	else
	{
		update_option("zing_forum_version",ZING_FORUM_VERSION);
	}
	if ($handle = opendir(dirname(__FILE__).'/db')) {
		$files=array();
		while (false !== ($file = readdir($handle))) {
			if (strstr($file,".sql")) {
				$f=explode("-",$file);

				$v=str_replace(".sql","",$f[1]);
				if ($zing_version < $v) {
					$files[]=dirname(__FILE__).'/db/'.$file;
				}
			}
		}
		closedir($handle);
		asort($files);
		if (count($files) > 0) {
			foreach ($files as $file) {
				$file_content = file($file);
				$query = "";
				foreach($file_content as $sql_line) {
					$tsl = trim($sql_line);
					if (($sql_line != "") && (substr($tsl, 0, 2) != "--") && (substr($tsl, 0, 1) != "#")) {
						$sql_line = str_replace("CREATE TABLE `", "CREATE TABLE `".$prefix, $sql_line);
						$sql_line = str_replace("CREATE TABLE IF NOT EXISTS `", "CREATE TABLE `".$prefix, $sql_line);
						$sql_line = str_replace("INSERT INTO `", "INSERT INTO `".$prefix, $sql_line);
						$sql_line = str_replace("ALTER TABLE `", "ALTER TABLE `".$prefix, $sql_line);
						$sql_line = str_replace("UPDATE `", "UPDATE `".$prefix, $sql_line);
						$sql_line = str_replace("TRUNCATE TABLE `", "TRUNCATE TABLE `".$prefix, $sql_line);
						$query .= $sql_line;

						if(preg_match("/;\s*$/", $sql_line)) {
							$wpdb->query($query);
							$query = "";
						}
					}
				}
			}
		}

	}

	//update forum URL
	$query="UPDATE `".$prefix."settings` SET `value`='".ZING_MYBB_URL."' WHERE `name`='bburl'";
	$wpdb->query($query);
	$query="UPDATE `".$prefix."settings` SET `value`='/' WHERE `name`='cookiepath'";
	$wpdb->query($query);
	
	//create pages
	if (!$zing_forum_version) {
		$pages=array();
		$pages[]=array("Forum","forum","*",0);

		$ids="";
		foreach ($pages as $i =>$p)
		{
			$my_post = array();
			$my_post['post_title'] = $p['0'];
			$my_post['post_content'] = '';
			$my_post['post_status'] = 'publish';
			$my_post['post_author'] = 1;
			$my_post['post_type'] = 'page';
			$my_post['menu_order'] = 100+$i;
			$my_post['comment_status'] = 'closed';
			$id=wp_insert_post( $my_post );
			if (empty($ids)) { $ids.=$id; } else { $ids.=",".$id; }
			if (!empty($p[1])) add_post_meta($id,'zing_forum_page',$p[1]);
		}
		if (get_option("zing_forum_pages"))
		{
			update_option("zing_forum_pages",$ids);
		}
		else {
			add_option("zing_forum_pages",$ids);
		}
	}
}

/**
 * Deactivation: nothing to do
 * @return void
 */
function zing_forum_deactivate() {
}

/**
 * Uninstallation: removal of database tables
 * @return void
 */
function zing_forum_uninstall() {
	global $wpdb;
	$prefix=$wpdb->prefix."zing_mybb_";
	$rows=$wpdb->get_results("show tables like '".$prefix."%'",ARRAY_N);
	foreach ($rows as $id => $row) {
		$query="drop table ".$row[0];
		$wpdb->query($query);
	}
	$ids=get_option("zing_forum_pages");
	$ida=explode(",",$ids);
	foreach ($ida as $id) {
		wp_delete_post($id);
	}
	delete_option("zing_forum_version",ZING_FORUM_VERSION);
	delete_option("zing_forum_pages",ZING_FORUM_VERSION);
}

/**
 * Main function handling content, footer and sidebars
 * @param $process
 * @param $content
 * @return unknown_type
 */
function zing_forum_main($process,$content="") {
	global $zing_forum_content;
	if ($zing_forum_content) {
		if ($zing_forum_content=="redirect") {
			header('Location:'.get_option('home').'/?page_id='.zing_forum_mainpage());
		}
		else {
			if ($_GET['action']=='logout') {
				unset($_SESSION['tmpfile']);
			}
			$content=$zing_forum_content;
		}
	}
	return $content;
}

function zing_forum_output($process) {
	global $post;
	global $wpdb;

	global $zing_forum_loaded,$zing_forum_to_include,$zing_forum_mode;

	switch ($process)
	{
		case "content":
			$cf=get_post_custom($post->ID);
			if (isset($_GET['zforum']))
			{
				$zing_forum_to_include=$_GET['zforum'];
				$zing_forum_mode="forum";
			}
			elseif (isset($_GET['zforumadmin']))
			{
				$zing_forum_to_include="admin/".$_GET['zforumadmin'];
				$zing_forum_mode="admin";
			}
			elseif (isset($_GET['module']))
			{
				$zing_forum_to_include="admin/index";
				$zing_forum_mode="admin";
			}
			elseif (isset($cf['zing_forum_page']))
			{
				if ($cf['zing_forum_page'][0]=='forum') {
					$zing_forum_to_include="index";
					$zing_forum_mode="forum";
				}
				if ($cf['zing_forum_page'][0]=='admin') {
					$zing_forum_to_include="admin/index";
					$zing_forum_mode="admin";
				}
			}
			else
			{
				return $content;
			}
			if (isset($cf['cat'])) {
				$_GET['cat']=$cf['cat'][0];
			}
			break;
	}
	$http=zing_forum_http("mybb",$zing_forum_to_include.'.php',$page);
	$news = new HTTPRequest($http);
	if (!$news->curlInstalled()) return "cURL not installed";
	elseif (!$news->live()) return "A HTTP Error occured";
	else {
		$output=$news->DownloadToString(true);
		$output=zing_forum_ob($output);
		if ($news->redirect) {
			header($output);
		}
		if (empty($output)) {
			return 'redirect';
		}
		else return '<!--forum:start--><div><br /></div>'.$output.'<!--forum:end-->';
	}
}

function zing_forum_http($module,$to_include="index",$page="",$key="") {
	$vars="";
	if (!$to_include) $to_include="index";
	$http=ZING_MYBB_URL.'/';
	$http.= $to_include;
	$and="";
	if (count($_GET) > 0) {
		foreach ($_GET as $n => $v) {
			if ($n!="zforum" && $n!="page_id" && $n!="zforumadmin") 
			{
				$vars.= $and.$n.'='.zing_urlencode($v);
				$and="&";
			}
		}
	}
	$vars.=$and.'zing='.zing_urlencode(ZING_MYBB_URL);
	if ($vars) $http.='?'.$vars;
	return $http;
}

/**
 * Page content filter
 * @param $content
 * @return unknown_type
 */
function zing_forum_content($content) {
	return zing_forum_main("content",$content);
}


/**
 * Header hook: loads FWS addons and css files
 * @return unknown_type
 */
function zing_forum_header()
{
	global $zing_forum_content;
	global $zing_forum_menu;
	$output=zing_forum_output("content");

	zing_integrator_cut($output,'<div id="footer">','</div>'); //remove footer
	$zing_forum_content=$output;

	echo '<link rel="stylesheet" type="text/css" href="' . ZING_FORUM_URL . 'zing.css" media="screen" />';
}

function zing_forum_mainpage() {
	$ids=get_option("zing_forum_pages");
	$ida=explode(",",$ids);
	return $ida[0];

}
function zing_forum_ob($buffer) {
	global $zing_forum_mode;
	$self=str_replace('index.php','',$_SERVER['PHP_SELF']);
	$home=get_option("home")."/";
	$ids=get_option("zing_forum_pages");
	$ida=explode(",",$ids);
	$pid=zing_forum_mainpage();

	$buffer=str_replace(ZING_MYBB_URL."/admin/index.php",$home."index.php?page_id=".$pid."&zforumadmin=index",$buffer);
	$buffer=str_replace('href="'.ZING_MYBB_URL,'href="'.get_option('home'),$buffer);

	//css
	$buffer=str_replace(get_option('home').'/css.php',ZING_MYBB_URL.'/css.php',$buffer);

	//$buffer=str_replace('forumdisplay.php?',"index.php?zforum=forumdisplay&",$buffer);
	//$buffer=preg_replace('/([A-Za-z0-9_]*).php.(.*)/','index.php?zforum=$1&$2',$buffer);

	// replace by zing_integrator_tags($buffer,$bodyclass)
	//page header & footer
	$tagslist='head';
	$tags=explode(',',$tagslist);
	foreach ($tags as $tag)
	{
		$buffer=str_replace('<'.$tag,'<div id="zing'.$tag.'"',$buffer);
		$buffer=str_replace($tag.'>','div>',$buffer);
	}
	$buffer=str_replace('<body','<div class="zingbody"',$buffer);
	$buffer=str_replace('body>','div>',$buffer);

	$buffer=preg_replace('/<html.*>/','',$buffer);
	$buffer=preg_replace('/<.html>/','',$buffer);
	$buffer=preg_replace('/<meta.*>/','',$buffer);
	$buffer=preg_replace('/<title>.*<.title>/','',$buffer);
	$buffer=preg_replace('/<.DOCTYPE.*>/','',$buffer);
	//images
	$buffer=str_replace('src="images/','src="'.ZING_MYBB_URL.'/images/',$buffer);

	//hide logo
	$buffer=str_replace('class="logo"','class="logo" style="display:none"',$buffer);
	$buffer=str_replace('id="logo"','id="logo" style="display:none"',$buffer);
	if ($zing_forum_mode=="forum") {
		//special cases - quickLogin
		//$buffer=str_replace(ZING_MYBB_URL."/member.php?action=login",wp_login_url($home."?page_id".$pid),$buffer);
		$buffer=str_replace('onclick="MyBB.quickLogin(); return false;"','',$buffer);

		//pages
		//$pageslist='index,showthread,usercp,modcp,private,search,memberlist,member,calendar,misc,forumdisplay,showteam,stats,newthread';
		$pageslist='index,announcements,attachment,calendar,editpost,forumdisplay,global,managegroup,member,memberlist,modcp,moderation,newreply,newthread,online,polls,portal,printthread,private,ratethread,report,reputation,rss,search,sendthread,showteam,showthread,stats,syndication,task,usercp,usercp2,warnings,xmlhttp';
		$pages=explode(",",$pageslist);
		//special pages: css

		$buffer=str_replace('"'.$home.'index.php"','"'.$home.'index.php?page_id='.$pid.'"',$buffer);
		foreach ($pages as $page) {
			$buffer=str_replace(ZING_MYBB_URL."/".$page.".php?",$home."index.php?page_id=".$pid."&zforum=".$page."&",$buffer);
			$buffer=str_replace(ZING_MYBB_URL."/".$page.".php",$home."index.php?page_id=".$pid."&zforum=".$page,$buffer);
		}
		unset($pages[0]);
		foreach ($pages as $page) {
			$buffer=str_replace($home.$page.".php?",$home."index.php?page_id=".$pid."&zforum=".$page."&",$buffer);
			$buffer=str_replace($home.$page.".php",$home."index.php?page_id=".$pid."&zforum=".$page,$buffer);
			$buffer=str_replace($page.".php?","index.php?page_id=".$pid."&zforum=".$page."&",$buffer);
			$buffer=str_replace($page.".php","index.php?page_id=".$pid."&zforum=".$page,$buffer);
		}
		//menu
		$buffer=str_replace('<div id="header">','<div>',$buffer);
		
		//javascripts
		$buffer=str_replace('../jscripts/',ZING_MYBB_URL.'/jscripts/',$buffer);
		$buffer=str_replace('./jscripts/',ZING_MYBB_URL.'/jscripts/',$buffer);
		$buffer=str_replace('src="jscripts/','src="'.ZING_MYBB_URL.'/jscripts/',$buffer);
		
		//captcha
		$buffer=str_replace('src="captcha.php?','src="'.ZING_MYBB_URL.'/captcha.php?',$buffer);


	} else {

		//admin pages
		$pageslist='index';
		$mybb=ZING_MYBB_URL."/admin/";
		$pages=explode(",",$pageslist);
		foreach ($pages as $page) {
			$buffer=str_replace($mybb.$page.".php?",$home."index.php?page_id=".$pid."&zforumadmin=".$page."&",$buffer);
			$buffer=str_replace($mybb.$page.".php",$home."index.php?page_id=".$pid."&zforumadmin=".$page,$buffer);
			$buffer=str_replace($self.'wp-content/plugins/zingiri-forum/mybb/admin/'.$page.".php?",$home."index.php?page_id=".$pid."&zforumadmin=".$page.'&',$buffer);
			///wordpress/wp-content/plugins/zingiri-forum/mybb/admin/
		}

		$buffer=str_replace('index.php?module=',$home.'index.php?page_id='.$pid.'&module=',$buffer);
		//admin style sheets
		$styles=array('default','sharepoint');
		foreach ($styles as $style) {
			$buffer=str_replace('./styles/'.$style.'/',ZING_MYBB_URL.'/admin/styles/zingiri/',$buffer);
			$buffer=str_replace('styles/'.$style.'/',ZING_MYBB_URL.'/admin/styles/zingiri/',$buffer);
		}
		//special cases
		$buffer=str_replace('"index.php"',$home.'index.php?page_id='.$pid.'&zforumadmin=index',$buffer);
		//		$buffer=str_replace(ZING_MYBB_URL,$home.'index.php?page_id='.$pid.'',$buffer);
		$buffer=str_replace('"'.get_option("home").'"','"'.get_option("home").'?page_id='.$pid.'"',$buffer);

		//iframe
		$buffer=str_replace('<iframe src="index.php?page_id='.$pid.'&module=tools/php_info','<iframe src="'.ZING_MYBB_URL.'/admin/index.php?module=tools/php_info',$buffer);
		//javascripts
		$buffer=str_replace('../jscripts/',ZING_MYBB_URL.'/jscripts/',$buffer);
		$buffer=str_replace('./jscripts/',ZING_MYBB_URL.'/jscripts/',$buffer);
		$buffer=str_replace('<div id="menu">','<div id="zingmenu">',$buffer);

		//logout
		$buffer=str_replace('"index.php?action=logout"','"'.$home.'index.php?page_id='.$pid.'&zforumadmin=index&action=logout"',$buffer);
		$buffer=str_replace('&amp;','&',$buffer);
	}

	//redirect form
	$buffer=str_replace('"index.php"','"'.$home.'index.php?page_id='.$pid.'"&zforum=index',$buffer);

	return $buffer;
}
/**
 * Initialization of page, action & page_id arrays
 * @return unknown_type
 */
function zing_forum_init()
{
	global $zing_forum_mode;

	ob_start();
	session_start();

	if (isset($_GET['zforum']))
	{
		$zing_forum_mode="forum";
	}
	elseif (isset($_GET['zforumadmin']) || isset($_GET['module']))
	{
		$zing_forum_mode="admin";
	}
}
?>